/*
 *   NOTE: this is a machine generated file - editing not recommended
 * ----------------------------------------------------------------------------
 *  (C) Copyright Testing Technologies, 2000-2006.  All Rights Reserved.
 *
 *  All copies of this program, whether in whole or in part, and whether
 *  modified or not, must display this and all other embedded copyright
 *  and ownership notices in full.
 *
 *  See the file COPYRIGHT and LICENSE for details of redistribution
 *  and use.
 *
 *  You should have received a copy of the COPYRIGHT and LICENSE file
 *  along with this file; if not, write to the Testing Technologies,
 *  Rosenthaler Str. 13, 10119 Berlin, Germany.
 *
 * ----------------------------------------------------------------------------
 *
 *   Source File: f:\dte\workspace\IPv6_ETSI_STF276_P2\ttcn3\EtsiLibrary\LibIpv6\LibMultiRfcs\LibIpv6_MultiRfcs_TypesAndValues.ttcn
 *   File       : AuthHeader.java
 *
 *   This is a Java class providing a com.testingtech.ttcn.tci based decoding
 *   using tabular encoding information within a TTCN-3 file.
 *
 *   This file was generated by TabularCodecGenerator(version v0.2)
  *  at 16.03.2006 10:22:58
 *
 *   REVISION INFO:
 *        $Revision: 1.2 $ $Date: 2006/02/09 17:34:58 $
 * -----------------------------------------------------------------------------
 */
package com.testingtech.generated.codec;

import com.testingtech.ttcn.tci.codec.tabular.*;

import org.etsi.ttcn.tci.RecordValue;
import org.etsi.ttcn.tci.Value;


public class AuthHeader extends TabularRecord {
    public boolean present = false;
    public RecordValue rv;
    public UInt8 nextHeader;
    public UInt8 payloadLen;
    public UInt16 reserved;
    public UInt32 securityParametersIndex;
    public UInt32 sequenceNumber;
    public TabularOctetstring integrityCheckValue;

    public AuthHeader(Value theValue) {
        super(theValue);
        rv = (RecordValue) tciValue;

        /*
                                        */
    }

    public TabularObject decode(final TabularDecoder dec)
        throws TabularException {
        assert dec != null;

        present = isNext(dec);

        if (!present) {
            return null;
        }

        // -- nextHeader
        if (UInt8.isNext(dec)) {
            nextHeader = (UInt8) new UInt8(rv.getField("nextHeader"));
            nextHeader.decode(dec);
        } else {
            throw new TabularException(
                "Mandatory field 'nextHeader' of 'AuthHeader' missing");
        }

        // -- payloadLen
        if (UInt8.isNext(dec)) {
            payloadLen = (UInt8) new UInt8(rv.getField("payloadLen"));
            payloadLen.decode(dec);
        } else {
            throw new TabularException(
                "Mandatory field 'payloadLen' of 'AuthHeader' missing");
        }

        // -- reserved
        if (UInt16.isNext(dec)) {
            reserved = (UInt16) new UInt16(rv.getField("reserved"));
            reserved.decode(dec);
        } else {
            throw new TabularException(
                "Mandatory field 'reserved' of 'AuthHeader' missing");
        }

        // -- securityParametersIndex
        if (UInt32.isNext(dec)) {
            securityParametersIndex = (UInt32) new UInt32(rv.getField(
                        "securityParametersIndex"));
            securityParametersIndex.decode(dec);
        } else {
            throw new TabularException(
                "Mandatory field 'securityParametersIndex' of 'AuthHeader' missing");
        }

        // -- sequenceNumber
        if (UInt32.isNext(dec)) {
            sequenceNumber = (UInt32) new UInt32(rv.getField("sequenceNumber"));
            sequenceNumber.decode(dec);
        } else {
            throw new TabularException(
                "Mandatory field 'sequenceNumber' of 'AuthHeader' missing");
        }

        // -- integrityCheckValue
        if (TabularOctetstring.isNext(dec)) {
            integrityCheckValue = (TabularOctetstring) new TabularOctetstring(rv.getField(
                        "integrityCheckValue")) {
                        public int getLength() throws TabularException {
                            // 	Complex
                            // TODO: 1) no length encoding attribute available although no definitiv length restriction 
                            // on type level was available
                            // return 0 ;
                            throw new TabularException(
                                "Haven't implemented non-restricted decoding of field 'integrityCheckValue' in structure 'AuthHeader'");
                        }
                    }.decode(dec);
        }

        return this;
    }

    public TabularObject decode(TabularDecoder dec, int proceedingByteNumber)
        throws TabularException {
        throw new TabularException(
            "method decode(TabularDecoder dec, int proceedingByteNumber) not implemented by default");
    }

    public void encode(final TabularEncoder enc) throws TabularException {
        assert enc != null;

        // -- nextHeader
        nextHeader = new UInt8(rv.getField("nextHeader"));
        nextHeader.encode(enc);

        // -- payloadLen
        payloadLen = new UInt8(rv.getField("payloadLen"));
        payloadLen.encode(enc);

        // -- reserved
        reserved = new UInt16(rv.getField("reserved"));
        reserved.encode(enc);

        // -- securityParametersIndex
        securityParametersIndex = new UInt32(rv.getField(
                    "securityParametersIndex"));
        securityParametersIndex.encode(enc);

        // -- sequenceNumber
        sequenceNumber = new UInt32(rv.getField("sequenceNumber"));
        sequenceNumber.encode(enc);

        // -- integrityCheckValue
        integrityCheckValue = new TabularOctetstring(rv.getField(
                    "integrityCheckValue"));
        integrityCheckValue.encode(enc);

        return;
    }

    public void encode(TabularEncoder enc, int proceedingByteNumber)
        throws TabularException {
        throw new TabularException(
            "method encode(TabularEncoder enc, int proceedingByteNumber) not implemented by default");
    }

    public Value toValue() {
        safeFieldSet(rv, "nextHeader", nextHeader);
        safeFieldSet(rv, "payloadLen", payloadLen);
        safeFieldSet(rv, "reserved", reserved);
        safeFieldSet(rv, "securityParametersIndex", securityParametersIndex);
        safeFieldSet(rv, "sequenceNumber", sequenceNumber);
        safeFieldSet(rv, "integrityCheckValue", integrityCheckValue);

        return rv;
    }
}
