/*
 *   NOTE: this is a machine generated file - editing not recommended
 * ----------------------------------------------------------------------------
 *  (C) Copyright Testing Technologies, 2000-2006.  All Rights Reserved.
 *
 *  All copies of this program, whether in whole or in part, and whether
 *  modified or not, must display this and all other embedded copyright
 *  and ownership notices in full.
 *
 *  See the file COPYRIGHT and LICENSE for details of redistribution
 *  and use.
 *
 *  You should have received a copy of the COPYRIGHT and LICENSE file
 *  along with this file; if not, write to the Testing Technologies,
 *  Rosenthaler Str. 13, 10119 Berlin, Germany.
 *
 * ----------------------------------------------------------------------------
 *
 *   Source File: f:\dte\workspace\IPv6_ETSI_STF276_P2\ttcn3\EtsiLibrary\LibIpv6\LibCore\LibIpv6_Rfc2460Root_TypesAndValues.ttcn
 *   File       : EspHeader.java
 *
 *   This is a Java class providing a com.testingtech.ttcn.tci based decoding
 *   using tabular encoding information within a TTCN-3 file.
 *
 *   This file was generated by TabularCodecGenerator(version v0.2)
  *  at 16.03.2006 09:59:37
 *
 *   REVISION INFO:
 *        $Revision: 1.2 $ $Date: 2006/02/09 17:34:58 $
 * -----------------------------------------------------------------------------
 */
package com.testingtech.generated.codec;

import com.testingtech.ttcn.tci.codec.tabular.*;

import org.etsi.ttcn.tci.RecordValue;
import org.etsi.ttcn.tci.Value;


public class EspHeader extends TabularRecord {
    public boolean present = false;
    public RecordValue rv;
    public UInt32 securityParametersIndex;
    public UInt32 sequenceNumber;
    public TabularOctetstring initializationVector;
    public ExtensionHeaderList extHdrList;
    public TabularOctetstring data;
    public TabularOctetstring trafficFlowConfidentialityPadding;
    public TabularOctetstring padding;
    public UInt8 padLength;
    public UInt8 nextHdr;
    public TabularOctetstring integrityCheckValue;

    public EspHeader(Value theValue) {
        super(theValue);
        rv = (RecordValue) tciValue;

        /*
                                        */
    }

    public TabularObject decode(final TabularDecoder dec)
        throws TabularException {
        assert dec != null;

        present = isNext(dec);

        if (!present) {
            return null;
        }

        // -- securityParametersIndex
        if (UInt32.isNext(dec)) {
            securityParametersIndex = (UInt32) new UInt32(rv.getField(
                        "securityParametersIndex"));
            securityParametersIndex.decode(dec);
        } else {
            throw new TabularException(
                "Mandatory field 'securityParametersIndex' of 'EspHeader' missing");
        }

        // -- sequenceNumber
        if (UInt32.isNext(dec)) {
            sequenceNumber = (UInt32) new UInt32(rv.getField("sequenceNumber"));
            sequenceNumber.decode(dec);
        } else {
            throw new TabularException(
                "Mandatory field 'sequenceNumber' of 'EspHeader' missing");
        }

        // -- initializationVector
        if (TabularOctetstring.isNext(dec)) {
            initializationVector = (TabularOctetstring) new TabularOctetstring(rv.getField(
                        "initializationVector")) {
                        public int getLength() throws TabularException {
                            // 	Complex
                            // TODO: 1) no length encoding attribute available although no definitiv length restriction 
                            // on type level was available
                            // return 0 ;
                            throw new TabularException(
                                "Haven't implemented non-restricted decoding of field 'initializationVector' in structure 'EspHeader'");
                        }
                    }.decode(dec);
        }

        // -- extHdrList
        if (ExtensionHeaderList.isNext(dec)) {
            extHdrList = (ExtensionHeaderList) new ExtensionHeaderList(rv.getField(
                        "extHdrList"));
            extHdrList.decode(dec);
        }

        // -- data
        if (TabularOctetstring.isNext(dec)) {
            data = (TabularOctetstring) new TabularOctetstring(rv.getField(
                        "data")) {
                        public int getLength() throws TabularException {
                            // 	Complex
                            // TODO: 1) no length encoding attribute available although no definitiv length restriction 
                            // on type level was available
                            // return 0 ;
                            throw new TabularException(
                                "Haven't implemented non-restricted decoding of field 'data' in structure 'EspHeader'");
                        }
                    }.decode(dec);
        }

        // -- trafficFlowConfidentialityPadding
        if (TabularOctetstring.isNext(dec)) {
            trafficFlowConfidentialityPadding = (TabularOctetstring) new TabularOctetstring(rv.getField(
                        "trafficFlowConfidentialityPadding")) {
                        public int getLength() throws TabularException {
                            // 	Complex
                            // TODO: 1) no length encoding attribute available although no definitiv length restriction 
                            // on type level was available
                            // return 0 ;
                            throw new TabularException(
                                "Haven't implemented non-restricted decoding of field 'trafficFlowConfidentialityPadding' in structure 'EspHeader'");
                        }
                    }.decode(dec);
        }

        // -- padding
        if (TabularOctetstring.isNext(dec)) {
            padding = (TabularOctetstring) new TabularOctetstring(rv.getField(
                        "padding")) {
                        public int getLength() throws TabularException {
                            // 	Complex
                            // TODO: 1) no length encoding attribute available although no definitiv length restriction 
                            // on type level was available
                            // return 0 ;
                            throw new TabularException(
                                "Haven't implemented non-restricted decoding of field 'padding' in structure 'EspHeader'");
                        }
                    }.decode(dec);
        }

        // -- padLength
        if (UInt8.isNext(dec)) {
            padLength = (UInt8) new UInt8(rv.getField("padLength"));
            padLength.decode(dec);
        } else {
            throw new TabularException(
                "Mandatory field 'padLength' of 'EspHeader' missing");
        }

        // -- nextHdr
        if (UInt8.isNext(dec)) {
            nextHdr = (UInt8) new UInt8(rv.getField("nextHdr"));
            nextHdr.decode(dec);
        } else {
            throw new TabularException(
                "Mandatory field 'nextHdr' of 'EspHeader' missing");
        }

        // -- integrityCheckValue
        if (TabularOctetstring.isNext(dec)) {
            integrityCheckValue = (TabularOctetstring) new TabularOctetstring(rv.getField(
                        "integrityCheckValue")) {
                        public int getLength() throws TabularException {
                            // 	Complex
                            // TODO: 1) no length encoding attribute available although no definitiv length restriction 
                            // on type level was available
                            // return 0 ;
                            throw new TabularException(
                                "Haven't implemented non-restricted decoding of field 'integrityCheckValue' in structure 'EspHeader'");
                        }
                    }.decode(dec);
        }

        return this;
    }

    public TabularObject decode(TabularDecoder dec, int proceedingByteNumber)
        throws TabularException {
        throw new TabularException(
            "method decode(TabularDecoder dec, int proceedingByteNumber) not implemented by default");
    }

    public void encode(final TabularEncoder enc) throws TabularException {
        assert enc != null;

        // -- securityParametersIndex
        securityParametersIndex = new UInt32(rv.getField(
                    "securityParametersIndex"));
        securityParametersIndex.encode(enc);

        // -- sequenceNumber
        sequenceNumber = new UInt32(rv.getField("sequenceNumber"));
        sequenceNumber.encode(enc);

        // -- initializationVector
        if (!rv.getField("initializationVector").notPresent()) {
            initializationVector = new TabularOctetstring(rv.getField(
                        "initializationVector"));
            initializationVector.encode(enc);
        }

        // -- extHdrList
        if (!rv.getField("extHdrList").notPresent()) {
            extHdrList = new ExtensionHeaderList(rv.getField("extHdrList"));
            extHdrList.encode(enc);
        }

        // -- data
        if (!rv.getField("data").notPresent()) {
            data = new TabularOctetstring(rv.getField("data"));
            data.encode(enc);
        }

        // -- trafficFlowConfidentialityPadding
        if (!rv.getField("trafficFlowConfidentialityPadding").notPresent()) {
            trafficFlowConfidentialityPadding = new TabularOctetstring(rv.getField(
                        "trafficFlowConfidentialityPadding"));
            trafficFlowConfidentialityPadding.encode(enc);
        }

        // -- padding
        if (!rv.getField("padding").notPresent()) {
            padding = new TabularOctetstring(rv.getField("padding"));
            padding.encode(enc);
        }

        // -- padLength
        padLength = new UInt8(rv.getField("padLength"));
        padLength.encode(enc);

        // -- nextHdr
        nextHdr = new UInt8(rv.getField("nextHdr"));
        nextHdr.encode(enc);

        // -- integrityCheckValue
        integrityCheckValue = new TabularOctetstring(rv.getField(
                    "integrityCheckValue"));
        integrityCheckValue.encode(enc);

        return;
    }

    public void encode(TabularEncoder enc, int proceedingByteNumber)
        throws TabularException {
        throw new TabularException(
            "method encode(TabularEncoder enc, int proceedingByteNumber) not implemented by default");
    }

    public Value toValue() {
        safeFieldSet(rv, "securityParametersIndex", securityParametersIndex);
        safeFieldSet(rv, "sequenceNumber", sequenceNumber);
        safeFieldSet(rv, "initializationVector", initializationVector);
        safeFieldSet(rv, "extHdrList", extHdrList);
        safeFieldSet(rv, "data", data);
        safeFieldSet(rv, "trafficFlowConfidentialityPadding",
            trafficFlowConfidentialityPadding);
        safeFieldSet(rv, "padding", padding);
        safeFieldSet(rv, "padLength", padLength);
        safeFieldSet(rv, "nextHdr", nextHdr);
        safeFieldSet(rv, "integrityCheckValue", integrityCheckValue);

        return rv;
    }
}
