/*
 *   NOTE: this is a machine generated file - editing not recommended
 * ----------------------------------------------------------------------------
 *  (C) Copyright Testing Technologies, 2000-2006.  All Rights Reserved.
 *
 *  All copies of this program, whether in whole or in part, and whether
 *  modified or not, must display this and all other embedded copyright
 *  and ownership notices in full.
 *
 *  See the file COPYRIGHT and LICENSE for details of redistribution
 *  and use.
 *
 *  You should have received a copy of the COPYRIGHT and LICENSE file
 *  along with this file; if not, write to the Testing Technologies,
 *  Rosenthaler Str. 13, 10119 Berlin, Germany.
 *
 * ----------------------------------------------------------------------------
 *
 *   Source File: f:\dte\workspace\IPv6_ETSI_STF276_P2\ttcn3\EtsiLibrary\LibIpv6\LibCore\LibIpv6_Rfc2460Root_TypesAndValues.ttcn
 *   File       : FragmentHeader.java
 *
 *   This is a Java class providing a com.testingtech.ttcn.tci based decoding
 *   using tabular encoding information within a TTCN-3 file.
 *
 *   This file was generated by TabularCodecGenerator(version v0.2)
  *  at 16.03.2006 09:59:37
 *
 *   REVISION INFO:
 *        $Revision: 1.2 $ $Date: 2006/02/09 17:34:58 $
 * -----------------------------------------------------------------------------
 */
package com.testingtech.generated.codec;

import com.testingtech.ttcn.tci.codec.tabular.*;

import org.etsi.ttcn.tci.RecordValue;
import org.etsi.ttcn.tci.Value;


public class FragmentHeader extends TabularRecord {
    public boolean present = false;
    public RecordValue rv;
    public UInt8 nextHeader;
    public UInt8 reserved1;
    public UInt13 fragmentOffset;
    public UInt2 reserved2;
    public UInt1 moreFlag;
    public UInt32 identification;

    public FragmentHeader(Value theValue) {
        super(theValue);
        rv = (RecordValue) tciValue;

        /*
                                                        */
    }

    public TabularObject decode(final TabularDecoder dec)
        throws TabularException {
        assert dec != null;

        present = isNext(dec);

        if (!present) {
            return null;
        }

        // -- nextHeader
        if (UInt8.isNext(dec)) {
            nextHeader = (UInt8) new UInt8(rv.getField("nextHeader"));
            nextHeader.decode(dec);
        } else {
            throw new TabularException(
                "Mandatory field 'nextHeader' of 'FragmentHeader' missing");
        }

        dec.tag("nextHeader", nextHeader);
        dec.intTag("IPv6Header_payloadLength",
            dec.getIntTag("IPv6Header_payloadLength") - 8);

        // -- reserved1
        if (UInt8.isNext(dec)) {
            reserved1 = (UInt8) new UInt8(rv.getField("reserved1"));
            reserved1.decode(dec);
        } else {
            throw new TabularException(
                "Mandatory field 'reserved1' of 'FragmentHeader' missing");
        }

        // -- fragmentOffset
        if (UInt13.isNext(dec)) {
            fragmentOffset = (UInt13) new UInt13(rv.getField("fragmentOffset"));
            fragmentOffset.decode(dec);
        } else {
            throw new TabularException(
                "Mandatory field 'fragmentOffset' of 'FragmentHeader' missing");
        }

        // -- reserved2
        if (UInt2.isNext(dec)) {
            reserved2 = (UInt2) new UInt2(rv.getField("reserved2"));
            reserved2.decode(dec);
        } else {
            throw new TabularException(
                "Mandatory field 'reserved2' of 'FragmentHeader' missing");
        }

        // -- moreFlag
        if (UInt1.isNext(dec)) {
            moreFlag = (UInt1) new UInt1(rv.getField("moreFlag"));
            moreFlag.decode(dec);
        } else {
            throw new TabularException(
                "Mandatory field 'moreFlag' of 'FragmentHeader' missing");
        }

        // -- identification
        if (UInt32.isNext(dec)) {
            identification = (UInt32) new UInt32(rv.getField("identification"));
            identification.decode(dec);
        } else {
            throw new TabularException(
                "Mandatory field 'identification' of 'FragmentHeader' missing");
        }

        return this;
    }

    public TabularObject decode(TabularDecoder dec, int proceedingByteNumber)
        throws TabularException {
        throw new TabularException(
            "method decode(TabularDecoder dec, int proceedingByteNumber) not implemented by default");
    }

    public void encode(final TabularEncoder enc) throws TabularException {
        assert enc != null;

        // -- nextHeader
        nextHeader = new UInt8(rv.getField("nextHeader"));
        nextHeader.encode(enc);

        // -- reserved1
        reserved1 = new UInt8(rv.getField("reserved1"));
        reserved1.encode(enc);

        // -- fragmentOffset
        fragmentOffset = new UInt13(rv.getField("fragmentOffset"));
        fragmentOffset.encode(enc);

        // -- reserved2
        reserved2 = new UInt2(rv.getField("reserved2"));
        reserved2.encode(enc);

        // -- moreFlag
        moreFlag = new UInt1(rv.getField("moreFlag"));
        moreFlag.encode(enc);

        // -- identification
        identification = new UInt32(rv.getField("identification"));
        identification.encode(enc);

        return;
    }

    public void encode(TabularEncoder enc, int proceedingByteNumber)
        throws TabularException {
        throw new TabularException(
            "method encode(TabularEncoder enc, int proceedingByteNumber) not implemented by default");
    }

    public static boolean isNext(TabularDecoder dec) throws TabularException {
        assert dec != null;

        return (valueOf(dec.getTag("nextHeader")) == 44);
    }

    public Value toValue() {
        safeFieldSet(rv, "nextHeader", nextHeader);
        safeFieldSet(rv, "reserved1", reserved1);
        safeFieldSet(rv, "fragmentOffset", fragmentOffset);
        safeFieldSet(rv, "reserved2", reserved2);
        safeFieldSet(rv, "moreFlag", moreFlag);
        safeFieldSet(rv, "identification", identification);

        return rv;
    }
}
