/*
 *   NOTE: this is a machine generated file - editing not recommended
 * ----------------------------------------------------------------------------
 *  (C) Copyright Testing Technologies, 2000-2006.  All Rights Reserved.
 *
 *  All copies of this program, whether in whole or in part, and whether
 *  modified or not, must display this and all other embedded copyright
 *  and ownership notices in full.
 *
 *  See the file COPYRIGHT and LICENSE for details of redistribution
 *  and use.
 *
 *  You should have received a copy of the COPYRIGHT and LICENSE file
 *  along with this file; if not, write to the Testing Technologies,
 *  Rosenthaler Str. 13, 10119 Berlin, Germany.
 *
 * ----------------------------------------------------------------------------
 *
 *   Source File: f:\dte\workspace\IPv6_ETSI_STF276_P2\ttcn3\EtsiLibrary\LibIpv6\LibCore\LibIpv6_Rfc2460Root_TypesAndValues.ttcn
 *   File       : Ipv6Header.java
 *
 *   This is a Java class providing a com.testingtech.ttcn.tci based decoding
 *   using tabular encoding information within a TTCN-3 file.
 *
 *   This file was generated by TabularCodecGenerator(version v0.2)
  *  at 16.03.2006 09:59:36
 *
 *   REVISION INFO:
 *        $Revision: 1.2 $ $Date: 2006/02/09 17:34:58 $
 * -----------------------------------------------------------------------------
 */
package com.testingtech.generated.codec;

import com.testingtech.ttcn.tci.codec.tabular.*;

import org.etsi.ttcn.tci.RecordValue;
import org.etsi.ttcn.tci.Value;


public class Ipv6Header extends TabularRecord {
    public boolean present = false;
    public RecordValue rv;
    public UInt4 version;
    public UInt8 trafficClass;
    public UInt20 flowLabel;
    public UInt16 payloadLength;
    public UInt8 nextHeader;
    public UInt8 hopLimit;
    public Ipv6Address sourceAddress;
    public Ipv6Address destinationAddress;

    public Ipv6Header(Value theValue) {
        super(theValue);
        rv = (RecordValue) tciValue;

        /*
                                        */
    }

    public TabularObject decode(final TabularDecoder dec)
        throws TabularException {
        assert dec != null;

        present = isNext(dec);

        if (!present) {
            return null;
        }

        // -- version
        if (UInt4.isNext(dec)) {
            version = (UInt4) new UInt4(rv.getField("version"));
            version.decode(dec);
        } else {
            throw new TabularException(
                "Mandatory field 'version' of 'Ipv6Header' missing");
        }

        // -- trafficClass
        if (UInt8.isNext(dec)) {
            trafficClass = (UInt8) new UInt8(rv.getField("trafficClass"));
            trafficClass.decode(dec);
        } else {
            throw new TabularException(
                "Mandatory field 'trafficClass' of 'Ipv6Header' missing");
        }

        // -- flowLabel
        if (UInt20.isNext(dec)) {
            flowLabel = (UInt20) new UInt20(rv.getField("flowLabel"));
            flowLabel.decode(dec);
        } else {
            throw new TabularException(
                "Mandatory field 'flowLabel' of 'Ipv6Header' missing");
        }

        // -- payloadLength
        if (UInt16.isNext(dec)) {
            payloadLength = (UInt16) new UInt16(rv.getField("payloadLength"));
            payloadLength.decode(dec);
        } else {
            throw new TabularException(
                "Mandatory field 'payloadLength' of 'Ipv6Header' missing");
        }

        dec.intTag("IPv6Header_payloadLength", valueOf(payloadLength));

        // -- nextHeader
        if (UInt8.isNext(dec)) {
            nextHeader = (UInt8) new UInt8(rv.getField("nextHeader"));
            nextHeader.decode(dec);
        } else {
            throw new TabularException(
                "Mandatory field 'nextHeader' of 'Ipv6Header' missing");
        }

        dec.tag("nextHeader", nextHeader);

        // -- hopLimit
        if (UInt8.isNext(dec)) {
            hopLimit = (UInt8) new UInt8(rv.getField("hopLimit"));
            hopLimit.decode(dec);
        } else {
            throw new TabularException(
                "Mandatory field 'hopLimit' of 'Ipv6Header' missing");
        }

        // -- sourceAddress
        if (Ipv6Address.isNext(dec)) {
            sourceAddress = (Ipv6Address) new Ipv6Address(rv.getField(
                        "sourceAddress"));
            sourceAddress.decode(dec);
        } else {
            throw new TabularException(
                "Mandatory field 'sourceAddress' of 'Ipv6Header' missing");
        }

        // -- destinationAddress
        if (Ipv6Address.isNext(dec)) {
            destinationAddress = (Ipv6Address) new Ipv6Address(rv.getField(
                        "destinationAddress"));
            destinationAddress.decode(dec);
        } else {
            throw new TabularException(
                "Mandatory field 'destinationAddress' of 'Ipv6Header' missing");
        }

        return this;
    }

    public TabularObject decode(TabularDecoder dec, int proceedingByteNumber)
        throws TabularException {
        throw new TabularException(
            "method decode(TabularDecoder dec, int proceedingByteNumber) not implemented by default");
    }

    public void encode(final TabularEncoder enc) throws TabularException {
        assert enc != null;

        // -- version
        version = new UInt4(rv.getField("version"));
        version.encode(enc);

        // -- trafficClass
        trafficClass = new UInt8(rv.getField("trafficClass"));
        trafficClass.encode(enc);

        // -- flowLabel
        flowLabel = new UInt20(rv.getField("flowLabel"));
        flowLabel.encode(enc);

        // -- payloadLength
        payloadLength = new UInt16(rv.getField("payloadLength"));
        payloadLength.encode(enc);

        // -- nextHeader
        nextHeader = new UInt8(rv.getField("nextHeader"));
        nextHeader.encode(enc);

        // -- hopLimit
        hopLimit = new UInt8(rv.getField("hopLimit"));
        hopLimit.encode(enc);

        // -- sourceAddress
        sourceAddress = new Ipv6Address(rv.getField("sourceAddress"));
        sourceAddress.encode(enc);

        // -- destinationAddress
        destinationAddress = new Ipv6Address(rv.getField("destinationAddress"));
        destinationAddress.encode(enc);

        return;
    }

    public void encode(TabularEncoder enc, int proceedingByteNumber)
        throws TabularException {
        throw new TabularException(
            "method encode(TabularEncoder enc, int proceedingByteNumber) not implemented by default");
    }

    public Value toValue() {
        safeFieldSet(rv, "version", version);
        safeFieldSet(rv, "trafficClass", trafficClass);
        safeFieldSet(rv, "flowLabel", flowLabel);
        safeFieldSet(rv, "payloadLength", payloadLength);
        safeFieldSet(rv, "nextHeader", nextHeader);
        safeFieldSet(rv, "hopLimit", hopLimit);
        safeFieldSet(rv, "sourceAddress", sourceAddress);
        safeFieldSet(rv, "destinationAddress", destinationAddress);

        return rv;
    }
}
