//-----------------------------------------------------------------------------
// 
//   NOTE: this is a machine generated file - editing not recommended
//   (C) Copyright Testing Technologies, 2003-2004.  All Rights Reserved.
//
//   See the file COPYRIGHT and LICENSE for details of redistribution
//   and use.
//
//   Source File: f:\dte\workspace\IPv6_ETSI_STF276_P2\ttcn3\EtsiLibrary\LibIpv6\LibMultiRfcs\LibIpv6_Interface.ttcn
//   File       : LibIpv6_Interface.java
//
//   This is a Java class providing a com.testingtech.ttcn.tci based decoding
//   using tabular encoding information within a TTCN-3 file.
//
//   This file was generated by TabularCodecGenerator at 14.03.2006 10:23:47
//-----------------------------------------------------------------------------
package com.testingtech.generated.codec;

import com.testingtech.ttcn.tci.ExtendedTciTypeClass;
import com.testingtech.ttcn.tci.codec.base.AbstractBaseCodec;
import com.testingtech.ttcn.tci.codec.tabular.TabularDecoder;
import com.testingtech.ttcn.tci.codec.tabular.TabularEncoder;
import com.testingtech.ttcn.tci.codec.tabular.TabularException;
import com.testingtech.ttcn.tri.TriMessageImpl;

import com.testingtech.util.BitArrayInputStream;
import com.testingtech.util.BitArrayOutputStream;

import de.tu_berlin.cs.uebb.muttcn.runtime.RB;
import de.tu_berlin.cs.uebb.muttcn.runtime.ValueImpl;

import org.etsi.ttcn.tci.Type;
import org.etsi.ttcn.tci.Value;
import org.etsi.ttcn.tri.TriMessage;


public class LibIpv6_Interface extends AbstractBaseCodec {
    private BitArrayInputStream bis = null;

    public LibIpv6_Interface(RB rb) {
        super(rb);
    }

    public Value decode(TriMessage rm, Type dh) {
        logDecode("LibIpv6_Interface: entering decode");
        assert rm != null : "TriMessage should never be null";
        assert dh != null : "DecodingHyp should never be null";

        Value v = null;
        byte[] em = rm.getEncodedMessage();
        bis = new BitArrayInputStream(em);

        TabularDecoder td = new TabularDecoder(bis);

        String typeName = dh.getName();
        logDecode("LibIpv6_Interface: typeName is " + typeName);

        if (dh.getTypeClass() == ExtendedTciTypeClass.ANY) {
            logDecode(
                "LibIpv6_Interface: decode(TriMessage, Type): decodingHypothesis is of typeClass ANY");

            Value theValue = dh.newInstance();

            ((ValueImpl) theValue).setPresent();
            logDecode(
                "LibIpv6_Interface: decode(TriMessage, Type): decodingHypothesis is of typeClass ANY: theValue.getClass().getName(): " +
                theValue.getClass().getName());

            return theValue;
        }

        try {
            // generated because of "isPDU=LibIpv6_Interface"
            if (typeName.equals("Ipv6Packet")) {
                Ipv6Packet d = new Ipv6Packet(dh.newInstance());
                d.decode(td);
                v = d.toValue();

                if ((v == null) || v.notPresent()) {
                    return null;
                }

                return v;
            }
        } catch (TabularException tex) {
            logDecode("LibIpv6_Interface: Aborting decoding for " + dh +
                ". Problem was " + tex.getCause().getMessage());

            return v;
        }

        if (typeName.equals("octetstring")) {
            return super.decode(rm, dh);
        } else if (typeName.equals("bitstring")) {
            return super.decode(rm, dh);
        } else if (typeName.equals("hexstring")) {
            return super.decode(rm, dh);
        } else if (typeName.equals("charstring")) {
            return super.decode(rm, dh);
        }

        return v;
    }

    public TriMessage encode(Value val) {
        BitArrayOutputStream baos = new BitArrayOutputStream();
        TabularEncoder enc = new TabularEncoder(baos);

        String typeName = val.getType().getName();

        try {
            // generated because of "isPDU=LibIpv6_Interface"
            if (typeName.equals("Ipv6Packet")) {
                Ipv6Packet d = new Ipv6Packet(val);
                d.encode(enc);

                return new TriMessageImpl(enc.toByteArray());
            }
        } catch (TabularException tex) {
            logDecode(
                "LibIpv6_Interface:: An error encountered while encoding. Reason: " +
                tex.getCause().getMessage());

            return null;
        }

        if (typeName.equals("octetstring")) {
            return super.encode(val);
        } else if (typeName.equals("bitstring")) {
            return super.encode(val);
        } else if (typeName.equals("charstring")) {
            return super.encode(val);
        } else if (typeName.equals("hexstring")) {
            return super.encode(val);
        }

        return null;
    }
}
