/*
 *   NOTE: this is a machine generated file - editing not recommended
 * ----------------------------------------------------------------------------
 *  (C) Copyright Testing Technologies, 2000-2006.  All Rights Reserved.
 *
 *  All copies of this program, whether in whole or in part, and whether
 *  modified or not, must display this and all other embedded copyright
 *  and ownership notices in full.
 *
 *  See the file COPYRIGHT and LICENSE for details of redistribution
 *  and use.
 *
 *  You should have received a copy of the COPYRIGHT and LICENSE file
 *  along with this file; if not, write to the Testing Technologies,
 *  Rosenthaler Str. 13, 10119 Berlin, Germany.
 *
 * ----------------------------------------------------------------------------
 *
 *   Source File: f:\dte\workspace\IPv6_ETSI_STF276_P2\ttcn3\EtsiLibrary\LibIpv6\LibMultiRfcs\LibIpv6_MultiRfcs_TypesAndValues.ttcn
 *   File       : MipHeader.java
 *
 *   This is a Java class providing a com.testingtech.ttcn.tci based decoding
 *   using tabular encoding information within a TTCN-3 file.
 *
 *   This file was generated by TabularCodecGenerator(version v0.2)
  *  at 17.03.2006 13:14:35
 *
 *   REVISION INFO:
 *        $Revision: 1.2 $ $Date: 2006/02/09 17:34:58 $
 * -----------------------------------------------------------------------------
 */
package com.testingtech.generated.codec;

import com.testingtech.ttcn.tci.codec.tabular.*;

import org.etsi.ttcn.tci.RecordValue;
import org.etsi.ttcn.tci.Value;


public class MipHeader extends TabularRecord {
    public boolean present = false;
    public RecordValue rv;
    public UInt8 payloadProtocol;
    public UInt8 headerLen;
    public UInt8 mobilityHeaderType;
    public UInt8 reserved;
    public Oct2 checksum;
    public MipMessage mipMessage;

    public MipHeader(Value theValue) {
        super(theValue);
        rv = (RecordValue) tciValue;

        /*
                        isPDU=used for external function only!;
                                        */
    }

    public TabularObject decode(final TabularDecoder dec)
        throws TabularException {
        assert dec != null;

        present = isNext(dec);

        if (!present) {
            return null;
        }

        // -- payloadProtocol
        if (UInt8.isNext(dec)) {
            payloadProtocol = (UInt8) new UInt8(rv.getField("payloadProtocol"));
            payloadProtocol.decode(dec);
        } else {
            throw new TabularException(
                "Mandatory field 'payloadProtocol' of 'MipHeader' missing");
        }

        // -- headerLen
        if (UInt8.isNext(dec)) {
            headerLen = (UInt8) new UInt8(rv.getField("headerLen"));
            headerLen.decode(dec);
        } else {
            throw new TabularException(
                "Mandatory field 'headerLen' of 'MipHeader' missing");
        }

        dec.tag("hdrIntLen", headerLen);
        dec.intTag("hdrExtIntLen", ((valueOf(headerLen) * 8) + 8) - 6);

        // -- mobilityHeaderType
        if (UInt8.isNext(dec)) {
            mobilityHeaderType = (UInt8) new UInt8(rv.getField(
                        "mobilityHeaderType"));
            mobilityHeaderType.decode(dec);
        } else {
            throw new TabularException(
                "Mandatory field 'mobilityHeaderType' of 'MipHeader' missing");
        }

        dec.tag("mobilityHeaderType", mobilityHeaderType);

        // -- reserved
        if (UInt8.isNext(dec)) {
            reserved = (UInt8) new UInt8(rv.getField("reserved"));
            reserved.decode(dec);
        } else {
            throw new TabularException(
                "Mandatory field 'reserved' of 'MipHeader' missing");
        }

        // -- checksum
        if (Oct2.isNext(dec)) {
            checksum = (Oct2) new Oct2(rv.getField("checksum"));
            checksum.decode(dec);
        } else {
            throw new TabularException(
                "Mandatory field 'checksum' of 'MipHeader' missing");
        }

        // -- mipMessage
        if (MipMessage.isNext(dec)) {
            mipMessage = (MipMessage) new MipMessage(rv.getField("mipMessage"));
            mipMessage.decode(dec);
        } else {
            throw new TabularException(
                "Mandatory field 'mipMessage' of 'MipHeader' missing");
        }

        return this;
    }

    public TabularObject decode(TabularDecoder dec, int proceedingByteNumber)
        throws TabularException {
        throw new TabularException(
            "method decode(TabularDecoder dec, int proceedingByteNumber) not implemented by default");
    }

    public void encode(final TabularEncoder enc) throws TabularException {
        assert enc != null;

        // -- payloadProtocol
        payloadProtocol = new UInt8(rv.getField("payloadProtocol"));
        payloadProtocol.encode(enc);

        // -- headerLen
        headerLen = new UInt8(rv.getField("headerLen"));
        headerLen.encode(enc);

        // -- mobilityHeaderType
        mobilityHeaderType = new UInt8(rv.getField("mobilityHeaderType"));
        mobilityHeaderType.encode(enc);

        // -- reserved
        reserved = new UInt8(rv.getField("reserved"));
        reserved.encode(enc);

        // -- checksum
        checksum = new Oct2(rv.getField("checksum"));
        checksum.encode(enc);

        // -- mipMessage
        mipMessage = new MipMessage(rv.getField("mipMessage"));
        mipMessage.encode(enc);

        return;
    }

    public void encode(TabularEncoder enc, int proceedingByteNumber)
        throws TabularException {
        throw new TabularException(
            "method encode(TabularEncoder enc, int proceedingByteNumber) not implemented by default");
    }

    public Value toValue() {
        safeFieldSet(rv, "payloadProtocol", payloadProtocol);
        safeFieldSet(rv, "headerLen", headerLen);
        safeFieldSet(rv, "mobilityHeaderType", mobilityHeaderType);
        safeFieldSet(rv, "reserved", reserved);
        safeFieldSet(rv, "checksum", checksum);
        safeFieldSet(rv, "mipMessage", mipMessage);

        return rv;
    }
}
