/*
 *   NOTE: this is a machine generated file - editing not recommended
 * ----------------------------------------------------------------------------
 *  (C) Copyright Testing Technologies, 2000-2006.  All Rights Reserved.
 *
 *  All copies of this program, whether in whole or in part, and whether
 *  modified or not, must display this and all other embedded copyright
 *  and ownership notices in full.
 *
 *  See the file COPYRIGHT and LICENSE for details of redistribution
 *  and use.
 *
 *  You should have received a copy of the COPYRIGHT and LICENSE file
 *  along with this file; if not, write to the Testing Technologies,
 *  Rosenthaler Str. 13, 10119 Berlin, Germany.
 *
 * ----------------------------------------------------------------------------
 *
 *   Source File: f:\dte\workspace\IPv6_ETSI_STF276_P2\ttcn3\EtsiLibrary\LibIpv6\LibMobility\LibIpv6_Rfc3775Mipv6_TypesAndValues.ttcn
 *   File       : MipRouterAdvertisement.java
 *
 *   This is a Java class providing a com.testingtech.ttcn.tci based decoding
 *   using tabular encoding information within a TTCN-3 file.
 *
 *   This file was generated by TabularCodecGenerator(version v0.2)
  *  at 15.03.2006 18:57:09
 *
 *   REVISION INFO:
 *        $Revision: 1.2 $ $Date: 2006/02/09 17:34:58 $
 * -----------------------------------------------------------------------------
 */
package com.testingtech.generated.codec;

import com.testingtech.ttcn.tci.codec.helper.*;
import com.testingtech.ttcn.tci.codec.tabular.*;

import org.etsi.ttcn.tci.RecordValue;
import org.etsi.ttcn.tci.Value;


public class MipRouterAdvertisement extends TabularRecord {
    public boolean present = false;
    public RecordValue rv;
    public Ipv6Header ipv6Hdr;
    public ExtensionHeaderList extHdrList;
    public UInt8 icmpType;
    public UInt8 icmpCode;
    public Oct2 checksum;
    public UInt8 curHopLimit;
    public UInt1 mFlag;
    public UInt1 oFlag;
    public UInt1 hFlag;
    public UInt5 reserved;
    public UInt16 routerLifetime;
    public UInt32 reachableTime;
    public UInt32 retransTimer;
    public MipRtAdvOptions mipRtAdvOptions;

    public MipRouterAdvertisement(Value theValue) {
        super(theValue);
        rv = (RecordValue) tciValue;

        /*
                        isPDU=LibIpv6_Rfc3775MIPv6_TypesAndValues;
                                                                        */
    }

    public TabularObject decode(final TabularDecoder dec)
        throws TabularException {
        assert dec != null;

        present = isNext(dec);

        if (!present) {
            return null;
        }

        // -- ipv6Hdr
        if (Ipv6Header.isNext(dec)) {
            ipv6Hdr = (Ipv6Header) new Ipv6Header(rv.getField("ipv6Hdr"));
            ipv6Hdr.decode(dec);
        } else {
            throw new TabularException(
                "Mandatory field 'ipv6Hdr' of 'MipRouterAdvertisement' missing");
        }

        // -- extHdrList
        if (ExtensionHeaderList.isNext(dec)) {
            extHdrList = (ExtensionHeaderList) new ExtensionHeaderList(rv.getField(
                        "extHdrList"));
            extHdrList.decode(dec);
        }

        // -- icmpType
        if (UInt8.isNext(dec)) {
            icmpType = (UInt8) new UInt8(rv.getField("icmpType"));
            icmpType.decode(dec);
        } else {
            throw new TabularException(
                "Mandatory field 'icmpType' of 'MipRouterAdvertisement' missing");
        }

        // -- icmpCode
        if (UInt8.isNext(dec)) {
            icmpCode = (UInt8) new UInt8(rv.getField("icmpCode"));
            icmpCode.decode(dec);
        } else {
            throw new TabularException(
                "Mandatory field 'icmpCode' of 'MipRouterAdvertisement' missing");
        }

        // -- checksum
        if (Oct2.isNext(dec)) {
            checksum = (Oct2) new Oct2(rv.getField("checksum"));
            checksum.decode(dec);
        } else {
            throw new TabularException(
                "Mandatory field 'checksum' of 'MipRouterAdvertisement' missing");
        }

        // -- curHopLimit
        if (UInt8.isNext(dec)) {
            curHopLimit = (UInt8) new UInt8(rv.getField("curHopLimit"));
            curHopLimit.decode(dec);
        } else {
            throw new TabularException(
                "Mandatory field 'curHopLimit' of 'MipRouterAdvertisement' missing");
        }

        // -- mFlag
        if (UInt1.isNext(dec)) {
            mFlag = (UInt1) new UInt1(rv.getField("mFlag"));
            mFlag.decode(dec);
        } else {
            throw new TabularException(
                "Mandatory field 'mFlag' of 'MipRouterAdvertisement' missing");
        }

        // -- oFlag
        if (UInt1.isNext(dec)) {
            oFlag = (UInt1) new UInt1(rv.getField("oFlag"));
            oFlag.decode(dec);
        } else {
            throw new TabularException(
                "Mandatory field 'oFlag' of 'MipRouterAdvertisement' missing");
        }

        // -- hFlag
        if (UInt1.isNext(dec)) {
            hFlag = (UInt1) new UInt1(rv.getField("hFlag"));
            hFlag.decode(dec);
        } else {
            throw new TabularException(
                "Mandatory field 'hFlag' of 'MipRouterAdvertisement' missing");
        }

        // -- reserved
        if (UInt5.isNext(dec)) {
            reserved = (UInt5) new UInt5(rv.getField("reserved"));
            reserved.decode(dec);
        } else {
            throw new TabularException(
                "Mandatory field 'reserved' of 'MipRouterAdvertisement' missing");
        }

        // -- routerLifetime
        if (UInt16.isNext(dec)) {
            routerLifetime = (UInt16) new UInt16(rv.getField("routerLifetime"));
            routerLifetime.decode(dec);
        } else {
            throw new TabularException(
                "Mandatory field 'routerLifetime' of 'MipRouterAdvertisement' missing");
        }

        // -- reachableTime
        if (UInt32.isNext(dec)) {
            reachableTime = (UInt32) new UInt32(rv.getField("reachableTime"));
            reachableTime.decode(dec);
        } else {
            throw new TabularException(
                "Mandatory field 'reachableTime' of 'MipRouterAdvertisement' missing");
        }

        // -- retransTimer
        if (UInt32.isNext(dec)) {
            retransTimer = (UInt32) new UInt32(rv.getField("retransTimer"));
            retransTimer.decode(dec);
        } else {
            throw new TabularException(
                "Mandatory field 'retransTimer' of 'MipRouterAdvertisement' missing");
        }

        // -- mipRtAdvOptions
        if (MipRtAdvOptions.isNext(dec)) {
            mipRtAdvOptions = (MipRtAdvOptions) new MipRtAdvOptions(rv.getField(
                        "mipRtAdvOptions"));
            mipRtAdvOptions.decode(dec);
        }

        return this;
    }

    public TabularObject decode(TabularDecoder dec, int proceedingByteNumber)
        throws TabularException {
        throw new TabularException(
            "method decode(TabularDecoder dec, int proceedingByteNumber) not implemented by default");
    }

    public void encode(final TabularEncoder enc) throws TabularException {
        assert enc != null;

        // -- ipv6Hdr
        ipv6Hdr = new Ipv6Header(rv.getField("ipv6Hdr"));
        ipv6Hdr.encode(enc);

        // -- extHdrList
        if (!rv.getField("extHdrList").notPresent()) {
            extHdrList = new ExtensionHeaderList(rv.getField("extHdrList"));
            extHdrList.encode(enc);
        }

        // -- icmpType
        icmpType = new UInt8(rv.getField("icmpType"));
        icmpType.encode(enc);

        // -- icmpCode
        icmpCode = new UInt8(rv.getField("icmpCode"));
        icmpCode.encode(enc);

        // -- checksum
        checksum = new Oct2(rv.getField("checksum"));
        checksum.encode(enc);

        // -- curHopLimit
        curHopLimit = new UInt8(rv.getField("curHopLimit"));
        curHopLimit.encode(enc);

        // -- mFlag
        mFlag = new UInt1(rv.getField("mFlag"));
        mFlag.encode(enc);

        // -- oFlag
        oFlag = new UInt1(rv.getField("oFlag"));
        oFlag.encode(enc);

        // -- hFlag
        hFlag = new UInt1(rv.getField("hFlag"));
        hFlag.encode(enc);

        // -- reserved
        reserved = new UInt5(rv.getField("reserved"));
        reserved.encode(enc);

        // -- routerLifetime
        routerLifetime = new UInt16(rv.getField("routerLifetime"));
        routerLifetime.encode(enc);

        // -- reachableTime
        reachableTime = new UInt32(rv.getField("reachableTime"));
        reachableTime.encode(enc);

        // -- retransTimer
        retransTimer = new UInt32(rv.getField("retransTimer"));
        retransTimer.encode(enc);

        // -- mipRtAdvOptions
        if (!rv.getField("mipRtAdvOptions").notPresent()) {
            mipRtAdvOptions = new MipRtAdvOptions(rv.getField("mipRtAdvOptions"));
            mipRtAdvOptions.encode(enc);
        }

        return;
    }

    public void encode(TabularEncoder enc, int proceedingByteNumber)
        throws TabularException {
        throw new TabularException(
            "method encode(TabularEncoder enc, int proceedingByteNumber) not implemented by default");
    }

    public static boolean isNext(TabularDecoder dec) throws TabularException {
        assert dec != null;

        return SupportFunctions.checkHeaderAndType(dec, 58, 134);
    }

    public Value toValue() {
        safeFieldSet(rv, "ipv6Hdr", ipv6Hdr);
        safeFieldSet(rv, "extHdrList", extHdrList);
        safeFieldSet(rv, "icmpType", icmpType);
        safeFieldSet(rv, "icmpCode", icmpCode);
        safeFieldSet(rv, "checksum", checksum);
        safeFieldSet(rv, "curHopLimit", curHopLimit);
        safeFieldSet(rv, "mFlag", mFlag);
        safeFieldSet(rv, "oFlag", oFlag);
        safeFieldSet(rv, "hFlag", hFlag);
        safeFieldSet(rv, "reserved", reserved);
        safeFieldSet(rv, "routerLifetime", routerLifetime);
        safeFieldSet(rv, "reachableTime", reachableTime);
        safeFieldSet(rv, "retransTimer", retransTimer);
        safeFieldSet(rv, "mipRtAdvOptions", mipRtAdvOptions);

        return rv;
    }
}
