/*
 *   NOTE: this is a machine generated file - editing not recommended
 * ----------------------------------------------------------------------------
 *  (C) Copyright Testing Technologies, 2000-2006.  All Rights Reserved.
 *
 *  All copies of this program, whether in whole or in part, and whether
 *  modified or not, must display this and all other embedded copyright
 *  and ownership notices in full.
 *
 *  See the file COPYRIGHT and LICENSE for details of redistribution
 *  and use.
 *
 *  You should have received a copy of the COPYRIGHT and LICENSE file
 *  along with this file; if not, write to the Testing Technologies,
 *  Rosenthaler Str. 13, 10119 Berlin, Germany.
 *
 * ----------------------------------------------------------------------------
 *
 *   Source File: f:\dte\workspace\IPv6_ETSI_STF276_P2\ttcn3\EtsiLibrary\LibIpv6\LibCore\LibIpv6_Rfc2461NeighborDiscovery_TypesAndValues.ttcn
 *   File       : NeighborAdvertisement.java
 *
 *   This is a Java class providing a com.testingtech.ttcn.tci based decoding
 *   using tabular encoding information within a TTCN-3 file.
 *
 *   This file was generated by TabularCodecGenerator(version v0.2)
  *  at 15.03.2006 18:29:10
 *
 *   REVISION INFO:
 *        $Revision: 1.2 $ $Date: 2006/02/09 17:34:58 $
 * -----------------------------------------------------------------------------
 */
package com.testingtech.generated.codec;


/** generated on @deprecated "import", "use" is recommend! */
import com.testingtech.ttcn.tci.codec.helper.*;
import com.testingtech.ttcn.tci.codec.tabular.*;

import org.etsi.ttcn.tci.RecordValue;
import org.etsi.ttcn.tci.Value;


public class NeighborAdvertisement extends TabularRecord {
    public boolean present = false;
    public RecordValue rv;
    public Ipv6Header ipv6Hdr;
    public ExtensionHeaderList extHdrList;
    public UInt8 icmpType;
    public UInt8 icmpCode;
    public Oct2 checksum;
    public UInt1 routerFlag;
    public UInt1 solicitedFlag;
    public UInt1 overrideFlag;
    public UInt29 reserved;
    public Ipv6Address targetAddr;
    public NbrAdvOptions nbrAdvOptions;

    public NeighborAdvertisement(Value theValue) {
        super(theValue);
        rv = (RecordValue) tciValue;

        /*
                        isPDU=LibIpv6_Rfc2461NeighborDiscovery_TypesAndValues;
                                                                        */
    }

    public TabularObject decode(final TabularDecoder dec)
        throws TabularException {
        assert dec != null;

        present = isNext(dec);

        if (!present) {
            return null;
        }

        // -- ipv6Hdr
        if (Ipv6Header.isNext(dec)) {
            ipv6Hdr = (Ipv6Header) new Ipv6Header(rv.getField("ipv6Hdr"));
            ipv6Hdr.decode(dec);
        } else {
            throw new TabularException(
                "Mandatory field 'ipv6Hdr' of 'NeighborAdvertisement' missing");
        }

        // -- extHdrList
        if (ExtensionHeaderList.isNext(dec)) {
            extHdrList = (ExtensionHeaderList) new ExtensionHeaderList(rv.getField(
                        "extHdrList"));
            extHdrList.decode(dec);
        }

        // -- icmpType
        if (UInt8.isNext(dec)) {
            icmpType = (UInt8) new UInt8(rv.getField("icmpType"));
            icmpType.decode(dec);
        } else {
            throw new TabularException(
                "Mandatory field 'icmpType' of 'NeighborAdvertisement' missing");
        }

        // -- icmpCode
        if (UInt8.isNext(dec)) {
            icmpCode = (UInt8) new UInt8(rv.getField("icmpCode"));
            icmpCode.decode(dec);
        } else {
            throw new TabularException(
                "Mandatory field 'icmpCode' of 'NeighborAdvertisement' missing");
        }

        // -- checksum
        if (Oct2.isNext(dec)) {
            checksum = (Oct2) new Oct2(rv.getField("checksum"));
            checksum.decode(dec);
        } else {
            throw new TabularException(
                "Mandatory field 'checksum' of 'NeighborAdvertisement' missing");
        }

        // -- routerFlag
        if (UInt1.isNext(dec)) {
            routerFlag = (UInt1) new UInt1(rv.getField("routerFlag"));
            routerFlag.decode(dec);
        } else {
            throw new TabularException(
                "Mandatory field 'routerFlag' of 'NeighborAdvertisement' missing");
        }

        // -- solicitedFlag
        if (UInt1.isNext(dec)) {
            solicitedFlag = (UInt1) new UInt1(rv.getField("solicitedFlag"));
            solicitedFlag.decode(dec);
        } else {
            throw new TabularException(
                "Mandatory field 'solicitedFlag' of 'NeighborAdvertisement' missing");
        }

        // -- overrideFlag
        if (UInt1.isNext(dec)) {
            overrideFlag = (UInt1) new UInt1(rv.getField("overrideFlag"));
            overrideFlag.decode(dec);
        } else {
            throw new TabularException(
                "Mandatory field 'overrideFlag' of 'NeighborAdvertisement' missing");
        }

        // -- reserved
        if (UInt29.isNext(dec)) {
            reserved = (UInt29) new UInt29(rv.getField("reserved"));
            reserved.decode(dec);
        } else {
            throw new TabularException(
                "Mandatory field 'reserved' of 'NeighborAdvertisement' missing");
        }

        // -- targetAddr
        if (Ipv6Address.isNext(dec)) {
            targetAddr = (Ipv6Address) new Ipv6Address(rv.getField("targetAddr"));
            targetAddr.decode(dec);
        } else {
            throw new TabularException(
                "Mandatory field 'targetAddr' of 'NeighborAdvertisement' missing");
        }

        // -- nbrAdvOptions
        if (NbrAdvOptions.isNext(dec)) {
            nbrAdvOptions = (NbrAdvOptions) new NbrAdvOptions(rv.getField(
                        "nbrAdvOptions"));
            nbrAdvOptions.decode(dec);
        }

        return this;
    }

    public TabularObject decode(TabularDecoder dec, int proceedingByteNumber)
        throws TabularException {
        throw new TabularException(
            "method decode(TabularDecoder dec, int proceedingByteNumber) not implemented by default");
    }

    public void encode(final TabularEncoder enc) throws TabularException {
        assert enc != null;

        // -- ipv6Hdr
        ipv6Hdr = new Ipv6Header(rv.getField("ipv6Hdr"));
        ipv6Hdr.encode(enc);

        // -- extHdrList
        if (!rv.getField("extHdrList").notPresent()) {
            extHdrList = new ExtensionHeaderList(rv.getField("extHdrList"));
            extHdrList.encode(enc);
        }

        // -- icmpType
        icmpType = new UInt8(rv.getField("icmpType"));
        icmpType.encode(enc);

        // -- icmpCode
        icmpCode = new UInt8(rv.getField("icmpCode"));
        icmpCode.encode(enc);

        // -- checksum
        checksum = new Oct2(rv.getField("checksum"));
        checksum.encode(enc);

        // -- routerFlag
        routerFlag = new UInt1(rv.getField("routerFlag"));
        routerFlag.encode(enc);

        // -- solicitedFlag
        solicitedFlag = new UInt1(rv.getField("solicitedFlag"));
        solicitedFlag.encode(enc);

        // -- overrideFlag
        overrideFlag = new UInt1(rv.getField("overrideFlag"));
        overrideFlag.encode(enc);

        // -- reserved
        reserved = new UInt29(rv.getField("reserved"));
        reserved.encode(enc);

        // -- targetAddr
        targetAddr = new Ipv6Address(rv.getField("targetAddr"));
        targetAddr.encode(enc);

        // -- nbrAdvOptions
        if (!rv.getField("nbrAdvOptions").notPresent()) {
            nbrAdvOptions = new NbrAdvOptions(rv.getField("nbrAdvOptions"));
            nbrAdvOptions.encode(enc);
        }

        return;
    }

    public void encode(TabularEncoder enc, int proceedingByteNumber)
        throws TabularException {
        throw new TabularException(
            "method encode(TabularEncoder enc, int proceedingByteNumber) not implemented by default");
    }

    public static boolean isNext(TabularDecoder dec) throws TabularException {
        assert dec != null;

        return SupportFunctions.checkHeaderAndType(dec, 58, 136);
    }

    public Value toValue() {
        safeFieldSet(rv, "ipv6Hdr", ipv6Hdr);
        safeFieldSet(rv, "extHdrList", extHdrList);
        safeFieldSet(rv, "icmpType", icmpType);
        safeFieldSet(rv, "icmpCode", icmpCode);
        safeFieldSet(rv, "checksum", checksum);
        safeFieldSet(rv, "routerFlag", routerFlag);
        safeFieldSet(rv, "solicitedFlag", solicitedFlag);
        safeFieldSet(rv, "overrideFlag", overrideFlag);
        safeFieldSet(rv, "reserved", reserved);
        safeFieldSet(rv, "targetAddr", targetAddr);
        safeFieldSet(rv, "nbrAdvOptions", nbrAdvOptions);

        return rv;
    }
}
