/*
 *   NOTE: this is a machine generated file - editing not recommended
 * ----------------------------------------------------------------------------
 *  (C) Copyright Testing Technologies, 2000-2006.  All Rights Reserved.
 *
 *  All copies of this program, whether in whole or in part, and whether
 *  modified or not, must display this and all other embedded copyright
 *  and ownership notices in full.
 *
 *  See the file COPYRIGHT and LICENSE for details of redistribution
 *  and use.
 *
 *  You should have received a copy of the COPYRIGHT and LICENSE file
 *  along with this file; if not, write to the Testing Technologies,
 *  Rosenthaler Str. 13, 10119 Berlin, Germany.
 *
 * ----------------------------------------------------------------------------
 *
 *   Source File: f:\dte\workspace\IPv6_ETSI_STF276_P2\ttcn3\EtsiLibrary\LibIpv6\LibCore\LibIpv6_Rfc2894RouterRenumbering_TypesAndValues.ttcn
 *   File       : RouterRenumbering.java
 *
 *   This is a Java class providing a com.testingtech.ttcn.tci based decoding
 *   using tabular encoding information within a TTCN-3 file.
 *
 *   This file was generated by TabularCodecGenerator(version v0.2)
  *  at 14.03.2006 11:27:43
 *
 *   REVISION INFO:
 *        $Revision: 1.2 $ $Date: 2006/02/09 17:34:58 $
 * -----------------------------------------------------------------------------
 */
package com.testingtech.generated.codec;

import com.testingtech.ttcn.tci.codec.helper.*;
import com.testingtech.ttcn.tci.codec.tabular.*;

import org.etsi.ttcn.tci.RecordValue;
import org.etsi.ttcn.tci.Value;


public class RouterRenumbering extends TabularRecord {
    public boolean present = false;
    public RecordValue rv;
    public Ipv6Header ipv6Hdr;
    public ExtensionHeaderList extHdrList;
    public UInt8 icmpType;
    public UInt8 icmpCode;
    public Oct2 checksum;
    public UInt32 sequenceNumber;
    public UInt8 segmentNumber;
    public UInt1 tFlag;
    public UInt1 rFlag;
    public UInt1 AFlag;
    public UInt1 sFlag;
    public UInt1 pFlag;
    public UInt3 reserved1;
    public UInt16 maxDelay;
    public UInt32 reserved2;
    public RrBody rrBody;

    public RouterRenumbering(Value theValue) {
        super(theValue);
        rv = (RecordValue) tciValue;

        /*
                        isPDU=LibIpv6_Rfc2894RouterRenumbering_TypesAndValues;
                                                                                        */
    }

    public TabularObject decode(final TabularDecoder dec)
        throws TabularException {
        assert dec != null;

        present = isNext(dec);

        if (!present) {
            return null;
        }

        // -- ipv6Hdr
        if (Ipv6Header.isNext(dec)) {
            ipv6Hdr = (Ipv6Header) new Ipv6Header(rv.getField("ipv6Hdr"));
            ipv6Hdr.decode(dec);
        } else {
            throw new TabularException(
                "Mandatory field 'ipv6Hdr' of 'RouterRenumbering' missing");
        }

        // -- extHdrList
        if (ExtensionHeaderList.isNext(dec)) {
            extHdrList = (ExtensionHeaderList) new ExtensionHeaderList(rv.getField(
                        "extHdrList"));
            extHdrList.decode(dec);
        }

        // -- icmpType
        if (UInt8.isNext(dec)) {
            icmpType = (UInt8) new UInt8(rv.getField("icmpType"));
            icmpType.decode(dec);
        } else {
            throw new TabularException(
                "Mandatory field 'icmpType' of 'RouterRenumbering' missing");
        }

        // -- icmpCode
        if (UInt8.isNext(dec)) {
            icmpCode = (UInt8) new UInt8(rv.getField("icmpCode"));
            icmpCode.decode(dec);
        } else {
            throw new TabularException(
                "Mandatory field 'icmpCode' of 'RouterRenumbering' missing");
        }

        dec.tag("icmpCode", icmpCode);

        // -- checksum
        if (Oct2.isNext(dec)) {
            checksum = (Oct2) new Oct2(rv.getField("checksum"));
            checksum.decode(dec);
        } else {
            throw new TabularException(
                "Mandatory field 'checksum' of 'RouterRenumbering' missing");
        }

        // -- sequenceNumber
        if (UInt32.isNext(dec)) {
            sequenceNumber = (UInt32) new UInt32(rv.getField("sequenceNumber"));
            sequenceNumber.decode(dec);
        } else {
            throw new TabularException(
                "Mandatory field 'sequenceNumber' of 'RouterRenumbering' missing");
        }

        // -- segmentNumber
        if (UInt8.isNext(dec)) {
            segmentNumber = (UInt8) new UInt8(rv.getField("segmentNumber"));
            segmentNumber.decode(dec);
        } else {
            throw new TabularException(
                "Mandatory field 'segmentNumber' of 'RouterRenumbering' missing");
        }

        // -- tFlag
        if (UInt1.isNext(dec)) {
            tFlag = (UInt1) new UInt1(rv.getField("tFlag"));
            tFlag.decode(dec);
        } else {
            throw new TabularException(
                "Mandatory field 'tFlag' of 'RouterRenumbering' missing");
        }

        // -- rFlag
        if (UInt1.isNext(dec)) {
            rFlag = (UInt1) new UInt1(rv.getField("rFlag"));
            rFlag.decode(dec);
        } else {
            throw new TabularException(
                "Mandatory field 'rFlag' of 'RouterRenumbering' missing");
        }

        // -- AFlag
        if (UInt1.isNext(dec)) {
            AFlag = (UInt1) new UInt1(rv.getField("AFlag"));
            AFlag.decode(dec);
        } else {
            throw new TabularException(
                "Mandatory field 'AFlag' of 'RouterRenumbering' missing");
        }

        // -- sFlag
        if (UInt1.isNext(dec)) {
            sFlag = (UInt1) new UInt1(rv.getField("sFlag"));
            sFlag.decode(dec);
        } else {
            throw new TabularException(
                "Mandatory field 'sFlag' of 'RouterRenumbering' missing");
        }

        // -- pFlag
        if (UInt1.isNext(dec)) {
            pFlag = (UInt1) new UInt1(rv.getField("pFlag"));
            pFlag.decode(dec);
        } else {
            throw new TabularException(
                "Mandatory field 'pFlag' of 'RouterRenumbering' missing");
        }

        // -- reserved1
        if (UInt3.isNext(dec)) {
            reserved1 = (UInt3) new UInt3(rv.getField("reserved1"));
            reserved1.decode(dec);
        } else {
            throw new TabularException(
                "Mandatory field 'reserved1' of 'RouterRenumbering' missing");
        }

        // -- maxDelay
        if (UInt16.isNext(dec)) {
            maxDelay = (UInt16) new UInt16(rv.getField("maxDelay"));
            maxDelay.decode(dec);
        } else {
            throw new TabularException(
                "Mandatory field 'maxDelay' of 'RouterRenumbering' missing");
        }

        // -- reserved2
        if (UInt32.isNext(dec)) {
            reserved2 = (UInt32) new UInt32(rv.getField("reserved2"));
            reserved2.decode(dec);
        } else {
            throw new TabularException(
                "Mandatory field 'reserved2' of 'RouterRenumbering' missing");
        }

        // -- rrBody
        if (RrBody.isNext(dec)) {
            rrBody = (RrBody) new RrBody(rv.getField("rrBody"));
            rrBody.decode(dec);
        }

        return this;
    }

    public TabularObject decode(TabularDecoder dec, int proceedingByteNumber)
        throws TabularException {
        throw new TabularException(
            "method decode(TabularDecoder dec, int proceedingByteNumber) not implemented by default");
    }

    public void encode(final TabularEncoder enc) throws TabularException {
        assert enc != null;

        // -- ipv6Hdr
        ipv6Hdr = new Ipv6Header(rv.getField("ipv6Hdr"));
        ipv6Hdr.encode(enc);

        // -- extHdrList
        if (!rv.getField("extHdrList").notPresent()) {
            extHdrList = new ExtensionHeaderList(rv.getField("extHdrList"));
            extHdrList.encode(enc);
        }

        // -- icmpType
        icmpType = new UInt8(rv.getField("icmpType"));
        icmpType.encode(enc);

        // -- icmpCode
        icmpCode = new UInt8(rv.getField("icmpCode"));
        icmpCode.encode(enc);

        // -- checksum
        checksum = new Oct2(rv.getField("checksum"));
        checksum.encode(enc);

        // -- sequenceNumber
        sequenceNumber = new UInt32(rv.getField("sequenceNumber"));
        sequenceNumber.encode(enc);

        // -- segmentNumber
        segmentNumber = new UInt8(rv.getField("segmentNumber"));
        segmentNumber.encode(enc);

        // -- tFlag
        tFlag = new UInt1(rv.getField("tFlag"));
        tFlag.encode(enc);

        // -- rFlag
        rFlag = new UInt1(rv.getField("rFlag"));
        rFlag.encode(enc);

        // -- AFlag
        AFlag = new UInt1(rv.getField("AFlag"));
        AFlag.encode(enc);

        // -- sFlag
        sFlag = new UInt1(rv.getField("sFlag"));
        sFlag.encode(enc);

        // -- pFlag
        pFlag = new UInt1(rv.getField("pFlag"));
        pFlag.encode(enc);

        // -- reserved1
        reserved1 = new UInt3(rv.getField("reserved1"));
        reserved1.encode(enc);

        // -- maxDelay
        maxDelay = new UInt16(rv.getField("maxDelay"));
        maxDelay.encode(enc);

        // -- reserved2
        reserved2 = new UInt32(rv.getField("reserved2"));
        reserved2.encode(enc);

        // -- rrBody
        if (!rv.getField("rrBody").notPresent()) {
            rrBody = new RrBody(rv.getField("rrBody"));
            rrBody.encode(enc);
        }

        return;
    }

    public void encode(TabularEncoder enc, int proceedingByteNumber)
        throws TabularException {
        throw new TabularException(
            "method encode(TabularEncoder enc, int proceedingByteNumber) not implemented by default");
    }

    public static boolean isNext(TabularDecoder dec) throws TabularException {
        assert dec != null;

        return SupportFunctions.checkHeaderAndType(dec, 58, 138);
    }

    public Value toValue() {
        safeFieldSet(rv, "ipv6Hdr", ipv6Hdr);
        safeFieldSet(rv, "extHdrList", extHdrList);
        safeFieldSet(rv, "icmpType", icmpType);
        safeFieldSet(rv, "icmpCode", icmpCode);
        safeFieldSet(rv, "checksum", checksum);
        safeFieldSet(rv, "sequenceNumber", sequenceNumber);
        safeFieldSet(rv, "segmentNumber", segmentNumber);
        safeFieldSet(rv, "tFlag", tFlag);
        safeFieldSet(rv, "rFlag", rFlag);
        safeFieldSet(rv, "AFlag", AFlag);
        safeFieldSet(rv, "sFlag", sFlag);
        safeFieldSet(rv, "pFlag", pFlag);
        safeFieldSet(rv, "reserved1", reserved1);
        safeFieldSet(rv, "maxDelay", maxDelay);
        safeFieldSet(rv, "reserved2", reserved2);
        safeFieldSet(rv, "rrBody", rrBody);

        return rv;
    }
}
