/*
 *   NOTE: this is a machine generated file - editing not recommended
 * ----------------------------------------------------------------------------
 *  (C) Copyright Testing Technologies, 2000-2006.  All Rights Reserved.
 *
 *  All copies of this program, whether in whole or in part, and whether
 *  modified or not, must display this and all other embedded copyright
 *  and ownership notices in full.
 *
 *  See the file COPYRIGHT and LICENSE for details of redistribution
 *  and use.
 *
 *  You should have received a copy of the COPYRIGHT and LICENSE file
 *  along with this file; if not, write to the Testing Technologies,
 *  Rosenthaler Str. 13, 10119 Berlin, Germany.
 *
 * ----------------------------------------------------------------------------
 *
 *   Source File: f:\dte\workspace\IPv6_ETSI_STF276_P2\ttcn3\EtsiLibrary\LibIpv6\LibCore\LibIpv6_Rfc2460Root_TypesAndValues.ttcn
 *   File       : RoutingHeader.java
 *
 *   This is a Java class providing a com.testingtech.ttcn.tci based decoding
 *   using tabular encoding information within a TTCN-3 file.
 *
 *   This file was generated by TabularCodecGenerator(version v0.2)
  *  at 16.03.2006 19:35:45
 *
 *   REVISION INFO:
 *        $Revision: 1.2 $ $Date: 2006/02/09 17:34:58 $
 * -----------------------------------------------------------------------------
 */
package com.testingtech.generated.codec;

import com.testingtech.ttcn.tci.codec.tabular.*;

import org.etsi.ttcn.tci.RecordValue;
import org.etsi.ttcn.tci.Value;


public class RoutingHeader extends TabularRecord {
    public boolean present = false;
    public RecordValue rv;
    public UInt8 nextHeader;
    public UInt8 hdrExtLen;
    public UInt8 routingType;
    public UInt8 segmentsLeft;
    public UInt32 reserved;
    public RoutingHeaderData routingHeaderData;

    public RoutingHeader(Value theValue) {
        super(theValue);
        rv = (RecordValue) tciValue;

        /*
                                                        */
    }

    public TabularObject decode(final TabularDecoder dec)
        throws TabularException {
        assert dec != null;

        present = isNext(dec);

        if (!present) {
            return null;
        }

        // -- nextHeader
        if (UInt8.isNext(dec)) {
            nextHeader = (UInt8) new UInt8(rv.getField("nextHeader"));
            nextHeader.decode(dec);
        } else {
            throw new TabularException(
                "Mandatory field 'nextHeader' of 'RoutingHeader' missing");
        }

        dec.tag("nextHeader", nextHeader);

        // -- hdrExtLen
        if (UInt8.isNext(dec)) {
            hdrExtLen = (UInt8) new UInt8(rv.getField("hdrExtLen"));
            hdrExtLen.decode(dec);
        } else {
            throw new TabularException(
                "Mandatory field 'hdrExtLen' of 'RoutingHeader' missing");
        }

        dec.tag("hdrExtLen", hdrExtLen);
        dec.intTag("hdrExtIntLen", ((valueOf(hdrExtLen) * 8) + 8) - 8);
        dec.intTag("IPv6Header_payloadLength",
            dec.getIntTag("IPv6Header_payloadLength") -
            (valueOf(hdrExtLen) * 8) - 8);

        // -- routingType
        if (UInt8.isNext(dec)) {
            routingType = (UInt8) new UInt8(rv.getField("routingType"));
            routingType.decode(dec);
        } else {
            throw new TabularException(
                "Mandatory field 'routingType' of 'RoutingHeader' missing");
        }

        dec.tag("routingType", routingType);

        // -- segmentsLeft
        if (UInt8.isNext(dec)) {
            segmentsLeft = (UInt8) new UInt8(rv.getField("segmentsLeft"));
            segmentsLeft.decode(dec);
        } else {
            throw new TabularException(
                "Mandatory field 'segmentsLeft' of 'RoutingHeader' missing");
        }

        // -- reserved
        if (UInt32.isNext(dec)) {
            reserved = (UInt32) new UInt32(rv.getField("reserved"));
            reserved.decode(dec);
        } else {
            throw new TabularException(
                "Mandatory field 'reserved' of 'RoutingHeader' missing");
        }

        // -- routingHeaderData
        if (RoutingHeaderData.isNext(dec)) {
            routingHeaderData = (RoutingHeaderData) new RoutingHeaderData(rv.getField(
                        "routingHeaderData"));
            routingHeaderData.decode(dec);
        }

        return this;
    }

    public TabularObject decode(TabularDecoder dec, int proceedingByteNumber)
        throws TabularException {
        throw new TabularException(
            "method decode(TabularDecoder dec, int proceedingByteNumber) not implemented by default");
    }

    public void encode(final TabularEncoder enc) throws TabularException {
        assert enc != null;

        // -- nextHeader
        nextHeader = new UInt8(rv.getField("nextHeader"));
        nextHeader.encode(enc);

        // -- hdrExtLen
        hdrExtLen = new UInt8(rv.getField("hdrExtLen"));
        hdrExtLen.encode(enc);

        // -- routingType
        routingType = new UInt8(rv.getField("routingType"));
        routingType.encode(enc);

        // -- segmentsLeft
        segmentsLeft = new UInt8(rv.getField("segmentsLeft"));
        segmentsLeft.encode(enc);

        // -- reserved
        reserved = new UInt32(rv.getField("reserved"));
        reserved.encode(enc);

        // -- routingHeaderData
        if (!rv.getField("routingHeaderData").notPresent()) {
            routingHeaderData = new RoutingHeaderData(rv.getField(
                        "routingHeaderData"));
            routingHeaderData.encode(enc);
        }

        return;
    }

    public void encode(TabularEncoder enc, int proceedingByteNumber)
        throws TabularException {
        throw new TabularException(
            "method encode(TabularEncoder enc, int proceedingByteNumber) not implemented by default");
    }

    public static boolean isNext(TabularDecoder dec) throws TabularException {
        assert dec != null;

        return (valueOf(dec.getTag("nextHeader")) == 43);
    }

    public Value toValue() {
        safeFieldSet(rv, "nextHeader", nextHeader);
        safeFieldSet(rv, "hdrExtLen", hdrExtLen);
        safeFieldSet(rv, "routingType", routingType);
        safeFieldSet(rv, "segmentsLeft", segmentsLeft);
        safeFieldSet(rv, "reserved", reserved);
        safeFieldSet(rv, "routingHeaderData", routingHeaderData);

        return rv;
    }
}
