/*
 *   NOTE: this is a machine generated file - editing not recommended
 * ----------------------------------------------------------------------------
 *  (C) Copyright Testing Technologies, 2000-2006.  All Rights Reserved.
 *
 *  All copies of this program, whether in whole or in part, and whether
 *  modified or not, must display this and all other embedded copyright
 *  and ownership notices in full.
 *
 *  See the file COPYRIGHT and LICENSE for details of redistribution
 *  and use.
 *
 *  You should have received a copy of the COPYRIGHT and LICENSE file
 *  along with this file; if not, write to the Testing Technologies,
 *  Rosenthaler Str. 13, 10119 Berlin, Germany.
 *
 * ----------------------------------------------------------------------------
 *
 *   Source File: f:\dte\workspace\IPv6_ETSI_STF276_P2\ttcn3\EtsiLibrary\LibIpv6\LibUdp\LibIpv6_Rfc0768Udp_TypesAndValues.ttcn
 *   File       : UdpPacket.java
 *
 *   This is a Java class providing a com.testingtech.ttcn.tci based decoding
 *   using tabular encoding information within a TTCN-3 file.
 *
 *   This file was generated by TabularCodecGenerator(version v0.2)
  *  at 14.03.2006 11:19:53
 *
 *   REVISION INFO:
 *        $Revision: 1.2 $ $Date: 2006/02/09 17:34:58 $
 * -----------------------------------------------------------------------------
 */
package com.testingtech.generated.codec;

import com.testingtech.ttcn.tci.codec.helper.*;
import com.testingtech.ttcn.tci.codec.tabular.*;

import org.etsi.ttcn.tci.RecordValue;
import org.etsi.ttcn.tci.Value;


public class UdpPacket extends TabularRecord {
    public boolean present = false;
    public RecordValue rv;
    public Ipv6Header ipv6Hdr;
    public ExtensionHeaderList extHdrList;
    public Oct2 sourcePort;
    public Oct2 destPort;
    public UInt16 msgLength;
    public Oct2 checksum;
    public TabularOctetstring data;

    public UdpPacket(Value theValue) {
        super(theValue);
        rv = (RecordValue) tciValue;

        /*
                        isPDU=LibIpv6_Rfc0768Udp_TypesAndValues;
                                                                        */
    }

    public TabularObject decode(final TabularDecoder dec)
        throws TabularException {
        assert dec != null;

        present = isNext(dec);

        if (!present) {
            return null;
        }

        // -- ipv6Hdr
        if (Ipv6Header.isNext(dec)) {
            ipv6Hdr = (Ipv6Header) new Ipv6Header(rv.getField("ipv6Hdr"));
            ipv6Hdr.decode(dec);
        } else {
            throw new TabularException(
                "Mandatory field 'ipv6Hdr' of 'UdpPacket' missing");
        }

        // -- extHdrList
        if (ExtensionHeaderList.isNext(dec)) {
            extHdrList = (ExtensionHeaderList) new ExtensionHeaderList(rv.getField(
                        "extHdrList"));
            extHdrList.decode(dec);
        }

        //decoding condition
        if (valueOf(dec.getTag("nextHeader")) != 17) {
            return null;
        }

        // -- sourcePort
        if (Oct2.isNext(dec)) {
            sourcePort = (Oct2) new Oct2(rv.getField("sourcePort"));
            sourcePort.decode(dec);
        } else {
            throw new TabularException(
                "Mandatory field 'sourcePort' of 'UdpPacket' missing");
        }

        // -- destPort
        if (Oct2.isNext(dec)) {
            destPort = (Oct2) new Oct2(rv.getField("destPort"));
            destPort.decode(dec);
        } else {
            throw new TabularException(
                "Mandatory field 'destPort' of 'UdpPacket' missing");
        }

        // -- msgLength
        if (UInt16.isNext(dec)) {
            msgLength = (UInt16) new UInt16(rv.getField("msgLength"));
            msgLength.decode(dec);
        } else {
            throw new TabularException(
                "Mandatory field 'msgLength' of 'UdpPacket' missing");
        }

        dec.tag("msgLength", msgLength);

        // -- checksum
        if (Oct2.isNext(dec)) {
            checksum = (Oct2) new Oct2(rv.getField("checksum"));
            checksum.decode(dec);
        } else {
            throw new TabularException(
                "Mandatory field 'checksum' of 'UdpPacket' missing");
        }

        // -- data
        if (TabularOctetstring.isNext(dec)) {
            data = (TabularOctetstring) new TabularOctetstring(rv.getField(
                        "data")) {
                        public int getLength() throws TabularException {
                            // 	Complex
                            return valueOf(dec.getTag("msgLength")) - 8;
                        }
                    }.decode(dec);
        }

        return this;
    }

    public TabularObject decode(TabularDecoder dec, int proceedingByteNumber)
        throws TabularException {
        throw new TabularException(
            "method decode(TabularDecoder dec, int proceedingByteNumber) not implemented by default");
    }

    public void encode(final TabularEncoder enc) throws TabularException {
        assert enc != null;

        // -- ipv6Hdr
        ipv6Hdr = new Ipv6Header(rv.getField("ipv6Hdr"));
        ipv6Hdr.encode(enc);

        // -- extHdrList
        if (!rv.getField("extHdrList").notPresent()) {
            extHdrList = new ExtensionHeaderList(rv.getField("extHdrList"));
            extHdrList.encode(enc);
        }

        // -- sourcePort
        sourcePort = new Oct2(rv.getField("sourcePort"));
        sourcePort.encode(enc);

        // -- destPort
        destPort = new Oct2(rv.getField("destPort"));
        destPort.encode(enc);

        // -- msgLength
        msgLength = new UInt16(rv.getField("msgLength"));
        msgLength.encode(enc);

        // -- checksum
        checksum = new Oct2(rv.getField("checksum"));
        checksum.encode(enc);

        // -- data
        if (!rv.getField("data").notPresent()) {
            data = new TabularOctetstring(rv.getField("data")) {
                        // 	Complex
                        // there is no code generation for complex length restrictions.
                    };
            data.encode(enc);
        }

        return;
    }

    public void encode(TabularEncoder enc, int proceedingByteNumber)
        throws TabularException {
        throw new TabularException(
            "method encode(TabularEncoder enc, int proceedingByteNumber) not implemented by default");
    }

    public static boolean isNext(TabularDecoder dec) throws TabularException {
        assert dec != null;

        return SupportFunctions.checkHeader(dec, 17);
    }

    public Value toValue() {
        safeFieldSet(rv, "ipv6Hdr", ipv6Hdr);
        safeFieldSet(rv, "extHdrList", extHdrList);
        safeFieldSet(rv, "sourcePort", sourcePort);
        safeFieldSet(rv, "destPort", destPort);
        safeFieldSet(rv, "msgLength", msgLength);
        safeFieldSet(rv, "checksum", checksum);
        safeFieldSet(rv, "data", data);

        return rv;
    }
}
