package com.testingtech.ttcn.tci.codec.helper;
import com.testingtech.ttcn.tci.codec.tabular.TabularDecoder;
import com.testingtech.ttcn.tci.codec.tabular.TabularException;

public class SupportFunctions {

    public static boolean checkHeaderAndType(TabularDecoder dec, int header, int type) throws TabularException {
        if (dec.bytes(6, 1, header)) {
            if (dec.bytes(40, 1, type)) {
                return true;
            }
        }
        else {
            int i=6;
            int lastHeader = -1;
            while (dec.bytes(i,1,0) || dec.bytes(i,1,41)  || dec.bytes(i,1,43) || dec.bytes(i,1,44) || dec.bytes(i,1,60) || dec.bytes(i,1,50) || dec.bytes(i,1,51)) {
                switch (lastHeader = dec.getBytes(i, 1)) {
                case 41:
                    i+=40;
                    break;
                case 44:
                	if (i != 6) {
                		i+=8;
                	}
                	else {
                		i+=34;
                	}
                    break;
                default:
                	if (i!=6) {
                		i += (dec.getBytes(++i, 1) + 7);
                	}
                	else {
                		i += 34;
                	}
                break;
                }
//                if (dec.bytes(i,1,41)) {
//                    lastHeader = 41;
//                    i+=40;
//                }
//                else if (!dec.bytes(i,1,44)) {
//                    lastHeader = dec.getBytes(i, 1);
//                    i += (dec.getBytes(++i, 1) + 7);
//                }
//                else {
//                    lastHeader = 44;
//                    i += 8;
//                }
            }
            if (dec.bytes(i, 1, header)) {
                switch (lastHeader) {
                case 41:
                    i+=34;
                    break;
                case 60:
                case 43:
                	i += (dec.getBytes(++i, 1) * 8 + 8);
                	break;
                case 44:
                    i+=8;
                    break;
                default:
                    i += (dec.getBytes(++i, 1) + 7);
                break;
                }
                if (dec.bytes(i, 1, type)) {
                    return true;
                }
            }
        }

        return false;
    }

    public static boolean checkHeader(TabularDecoder dec, int header) throws TabularException {
//    	System.err.println("checkHeader");
        if (dec.bytes(6, 1, header)) {
            return true;
        }
        else {
//            int i=6;
            int i=40;
            while (dec.bytes(i,1,0) || dec.bytes(i,1,41)  || dec.bytes(i,1,43) || dec.bytes(i,1,44) || dec.bytes(i,1,60) || dec.bytes(i,1,50) || dec.bytes(i,1,51)) {
            	switch (dec.getBytes(i, 1)) {
                case 60:
                case 41:
                    i+=40;
                    break;
                case 44:
                    i+=8;
                    break;
                default:
                    i += (dec.getBytes(++i, 1) + 7);
                break;
                }
            }
            if (dec.bytes(i, 1, header)) {
            	return true;
            }
        }

        return false;
    }

//    public static boolean checkHeaderAndType(TabularDecoder dec, int header, int type) throws TabularException {
//        if (dec.bytes(6, 1, 58)) {
//            if (dec.bytes(47, 1, 128)) {
//                return true;
//            }
//        }
//        else {
//            int i=6;
//            int lastHeader = -1;
//            while (dec.bytes(i,1,0) || dec.bytes(i,1,41)  || dec.bytes(i,1,43) || dec.bytes(i,1,44) || dec.bytes(i,1,60) || dec.bytes(i,1,50) || dec.bytes(i,1,51)) {
//                if (dec.bytes(i,1,41)) {
//                    lastHeader = 41;
//                    i+=40;
//                }
//                else if (!dec.bytes(i,1,44)) {
//                    lastHeader = dec.getBytes(i, 1);
//                    i += (dec.getBytes(++i, 1) + 7);
//                }
//                else {
//                    lastHeader = 44;
//                    i += 8;
//                }
//            }
//            if (dec.bytes(i, 1, 58)) {
//                switch (lastHeader) {
//                case 41:
//                    i+=34;
//                    break;
//                case 44:
//                    i+=8;
//                    break;
//                default:
//                    i += (dec.getBytes(++i, 1) + 7);
//                break;
//                }
//                if (dec.bytes(i, 1, 128)) {
//                    return true;
//                }
//            }
//        }
//
//        return false;
//    }
}
